## mygui 3.4.1+dfsg

=== CMakeLists.txt ===
######################################################################
# MYGUI BUILD SYSTEM
# Welcome to the CMake build system for MYGUI.
# This is the main file where we prepare the general build environment
# and provide build configuration options.
######################################################################

cmake_minimum_required(VERSION 2.8.12)
cmake_policy(SET CMP0003 NEW)
cmake_policy(SET CMP0011 NEW)
cmake_policy(SET CMP0048 OLD)

# for link time optimization, remove if cmake version is >= 3.9
if(POLICY CMP0069) # LTO
  cmake_policy(SET CMP0069 NEW)
endif()

# for position-independent executable, remove if cmake version is >= 3.14
if(POLICY CMP0083)
  cmake_policy(SET CMP0083 NEW)
endif()

project(MYGUI)

# Include necessary submodules
set(CMAKE_MODULE_PATH
	"${MYGUI_SOURCE_DIR}/CMake"
	"${MYGUI_SOURCE_DIR}/CMake/Utils"
	"${MYGUI_SOURCE_DIR}/CMake/Packages"
)
include(CMakeDependentOption)
include(MacroLogFeature)
include(MyGUIConfigTargets)
include(PreprocessorUtils)
include(GNUInstallDirs)
set(MYGUI_TEMPLATES_DIR "${MYGUI_SOURCE_DIR}/CMake/Templates")

SET(CMAKE_CXX_STANDARD 11)
set(CMAKE_EXPORT_COMPILE_COMMANDS True)

#####################################################################
# Set up the basic build environment
#####################################################################

if (CMAKE_BUILD_TYPE STREQUAL "")
	# CMake defaults to leaving CMAKE_BUILD_TYPE empty. This screws up
	# differentiation between debug and release builds.
	set(CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING "Choose the type of build, options are: None (CMAKE_CXX_FLAGS or CMAKE_C_FLAGS used) Debug Release RelWithDebInfo MinSizeRel." FORCE)
endif ()

# determine MyGUI version numbers
include(MyGUIGetVersion)
mygui_get_version(${MYGUI_SOURCE_DIR}/MyGUIEngine/include/MyGUI_Prerequest.h)
message(STATUS "Configuring MYGUI ${MYGUI_VERSION}")

if (NOT APPLE)
	# Create debug libraries with _d postfix
	set(CMAKE_DEBUG_POSTFIX "_d")
endif ()

if (CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang" OR CMAKE_CXX_COMPILER_ID MATCHES "Intel")
	# Test for GCC visibility
	include(CheckCXXCompilerFlag)
	check_cxx_compiler_flag(-fvisibility=hidden MYGUI_GCC_VISIBILITY)
	if (MYGUI_GCC_VISIBILITY)
		# determine gcc version
		execute_process(COMMAND ${CMAKE_CXX_COMPILER} -dumpversion OUTPUT_VARIABLE MYGUI_GCC_VERSION)
		message(STATUS "Detected g++ ${MYGUI_GCC_VERSION}")
		message(STATUS "Enabling GCC visibility flags")
		set(MYGUI_GCC_VISIBILITY_FLAGS "-DMYGUI_GCC_VISIBILITY -fvisibility=hidden")

		# check if we can safely add -fvisibility-inlines-hidden
		string(TOLOWER "${CMAKE_BUILD_TYPE}" MYGUI_BUILD_TYPE)
		if (MYGUI_BUILD_TYPE STREQUAL "debug")
			if(MYGUI_GCC_VERSION VERSION_LESS "4.2")
				message(STATUS "Skipping -fvisibility-inlines-hidden due to possible bug in g++ < 4.2")
			else() # double if because of bug in CMake 2.6
				set(MYGUI_GCC_VISIBILITY_FLAGS "${MYGUI_GCC_VISIBILITY_FLAGS} -fvisibility-inlines-hidden")
			endif()
		else ()
			set(MYGUI_GCC_VISIBILITY_FLAGS "${MYGUI_GCC_VISIBILITY_FLAGS} -fvisibility-inlines-hidden")
		endif ()
	endif (MYGUI_GCC_VISIBILITY)

	# Fix x64 issues on Linux
	if(("${CMAKE_SYSTEM_PROCESSOR}" STREQUAL "x86_64" OR "${CMAKE_SYSTEM_PROCESSOR}" STREQUAL "amd64") AND NOT APPLE)
		add_definitions(-fPIC)
	endif()
endif ()

# Specify build paths
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${MYGUI_BINARY_DIR}/${CMAKE_INSTALL_LIBDIR})
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${MYGUI_BINARY_DIR}/${CMAKE_INSTALL_LIBDIR})
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${MYGUI_BINARY_DIR}/${CMAKE_INSTALL_BINDIR})
if (WIN32 OR APPLE)
	if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
		if (UNIX)
			# On Mac OS X and Linux, standard behavior is to install to /usr/local/lib
			set(CMAKE_INSTALL_PREFIX "/usr/local")
		elseif (WIN32)
			# On Windows, we don't want to install in default system location, install is really for the SDK, so call it that
			SET(CMAKE_INSTALL_PREFIX
				"${MYGUI_BINARY_DIR}/sdk" CACHE PATH "MYGUI install prefix" FORCE
			)
		endif ()
	endif (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
endif(WIN32 OR APPLE)

######################################################################
# Provide user options to customise the build process
######################################################################

if (EMSCRIPTEN)
	set(MYGUI_STATIC True CACHE BOOL "")
	set(MYGUI_DISABLE_PLUGINS True CACHE BOOL "")

	set(SDL2_INCLUDE_DIR "." CACHE STRING "")
	set(SDL2_IMAGE_INCLUDE_DIR "." CACHE STRING "")

	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --std=c++11 -O2 -s ALLOW_MEMORY_GROWTH=1")
	# TODO: required only by demos and tools, not by MyGUIEngine or MyGUI.OpenGLESPlatform
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -s USE_SDL=2 -s USE_SDL_IMAGE=2 -s SDL2_IMAGE_FORMATS='[\"png\"]' -s FULL_ES3=1 -s USE_WEBGL2=1")
	# TODO: set preload-file flags for demos and tools only
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --preload-file ${CMAKE_CURRENT_SOURCE_DIR}/Media/@/Media")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --preload-file ${CMAKE_CURRENT_BINARY_DIR}/bin/resources.xml@/resources.xml")

	SET(CMAKE_EXECUTABLE_SUFFIX ".html")
endif ()

# Customise what to build
option(MYGUI_STATIC "Static build" FALSE)
option(MYGUI_DISABLE_PLUGINS "Disable plugins support" FALSE)
option(MYGUI_USE_FREETYPE "Use freetype for font texture rendering" TRUE)
option(MYGUI_MSDF_FONTS "Enable msdf fonts generation support" FALSE)
option(MYGUI_DONT_USE_OBSOLETE "Remove obsolete functions from build" FALSE)

set(MYGUI_RENDERSYSTEM 3 CACHE STRING
"Specify the Render System. Possible values:
  1 - Dummy
  2 - Export (not used)
  3 - Ogre
  4 - OpenGL
  5 - Direct3D 9
  6 - Direct3D 11
  7 - OpenGL 3.x
  8 - OpenGL ES 2.0 (Emscripten)"
)

if(MYGUI_RENDERSYSTEM EQUAL 4 OR MYGUI_RENDERSYSTEM EQUAL 7)
	option(MYGUI_USE_SYSTEM_GLEW "Use system OpenGL Extension Wrangler Library (GLEW)" FALSE)
endif()

option(MYGUI_BUILD_DEMOS "Build MyGUI demos" TRUE)
cmake_dependent_option(MYGUI_BUILD_PLUGINS "Build MyGUI plugins" TRUE "NOT MYGUI_DISABLE_PLUGINS" FALSE)
option(MYGUI_BUILD_TOOLS "Build the tools" TRUE)
option(MYGUI_BUILD_UNITTESTS "Build the unit tests" FALSE)
option(MYGUI_BUILD_TEST_APP "Build TestApp" FALSE)
option(MYGUI_BUILD_WRAPPER "Build the wrapper" FALSE)

cmake_dependent_option(MYGUI_INSTALL_DEMOS "Install MyGUI demos." FALSE "MYGUI_BUILD_DEMOS" FALSE)
cmake_dependent_option(MYGUI_INSTALL_TOOLS "Install MyGUI tools." FALSE "MYGUI_BUILD_TOOLS" FALSE)
option(MYGUI_INSTALL_DOCS "Install documentation." FALSE)
option(MYGUI_INSTALL_MEDIA "Install media files." FALSE)
cmake_dependent_option(MYGUI_INSTALL_PDB "Install debug pdb files" FALSE "MSVC;NOT MYGUI_STATIC" FALSE)
option(MYGUI_STANDALONE_BUILD "Generate build files that do not reference CMake (should be used only from Scripts/prepareRelease.py)" FALSE)
MARK_AS_ADVANCED(MYGUI_STANDALONE_BUILD)
option(MYGUI_GENERATE_LIST_FILES_FROM_VSPROJECT "Generate .list files from visual studio project files" FALSE)
MARK_AS_ADVANCED(MYGUI_GENERATE_LIST_FILES_FROM_VSPROJECT)

if (MSVC)
	option(MYGUI_USE_PROJECT_FOLDERS "Use Visual Studio solution folders for projects." TRUE)
endif ()

# Used to not annoy users with high level warnings (should be TRUE for developers)
option(MYGUI_HIGH_LEVEL_WARNINGS "Use high level compiler warnings. Developers should enable this." FALSE)

if (MYGUI_USE_PROJECT_FOLDERS)
	SET_PROPERTY(GLOBAL PROPERTY USE_FOLDERS ON)
endif ()

if (MYGUI_DONT_USE_OBSOLETE)
	add_definitions(-DMYGUI_DONT_USE_OBSOLETE)
endif ()
# End of Global defines

# Find dependencies
include(Dependencies)

# Set compiler specific build flags
if (CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang" OR CMAKE_CXX_COMPILER_ID MATCHES "Intel")
	if (NOT MYGUI_HIGH_LEVEL_WARNINGS)
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -w")
	else ()
		if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
			set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Weverything")
			# might be useful
			set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-documentation-unknown-command -Wno-unknown-warning-option -Wno-sign-conversion -Wno-conversion -Wno-documentation -Wno-old-style-cast")
			set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-poison-system-directories")
			# not useful
			set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-missing-prototypes -Wno-reorder -Wno-c++98-compat-pedantic -Wno-c++11-extensions -Wno-float-equal -Wno-padded -Wno-weak-vtables -Wno-duplicate-enum -Wno-exit-time-destructors -Wno-unused-parameter -Wno-global-constructors")
		else ()
			# very interesting option, but way too many warnings
			#add_definitions(-Weffc++)
			set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-deprecated -Wall -Wno-reorder -Winit-self -Woverloaded-virtual -Wcast-qual -Wwrite-strings -Wextra -Wno-unused-parameter")
			set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pedantic")
			if (NOT CMAKE_CXX_COMPILER_ID MATCHES "Intel")
				set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wctor-dtor-privacy")
				set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fdiagnostics-show-option")
			endif ()

			# MyGUI_UString.h ignored from warnings because of this
			set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wshadow")
		endif ()
	endif ()
endif ()

if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
	# usage:
	# UBSAN_OPTIONS=print_stacktrace=1,suppressions=sanitizers/UBSanitizer.supp <command>
	option(MYGUI_UB_SANITIZER "Compile with undefined behaviour sanitizer" FALSE)
	if (MYGUI_UB_SANITIZER)
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-omit-frame-pointer -fno-optimize-sibling-calls")
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=undefined -fno-sanitize-recover=undefined")
	endif()

	# usage:
	# ASAN_OPTIONS=alloc_dealloc_mismatch=0,check_initialization_order=1,detect_stack_use_after_return=1 LSAN_OPTIONS=suppressions=sanitizers/LeaksSanitizer.supp <command>
	# alloc_dealloc_mismatch is here due to issues with Ogre and no clear way to suppress the issue
	option(MYGUI_ADDRESS_SANITIZER "Compile with address sanitizer" FALSE)
	if (MYGUI_ADDRESS_SANITIZER)
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-omit-frame-pointer -fno-optimize-sibling-calls")
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address -fsanitize-address-use-after-scope")
	endif()
endif ()

if (MSVC)
	add_definitions("-D_CRT_SECURE_NO_WARNINGS")

	# Use the highest warning level for visual studio.
	if (MYGUI_HIGH_LEVEL_WARNINGS)
		SET(WARNING_LEVEL "/W4")
	else ()
		SET(WARNING_LEVEL "/W3")
	endif ()
	# disable: warning C4100: '***' : unreferenced formal parameter
	add_definitions(/wd4100)
	# disable: warning C4127: conditional expression is constant
	add_definitions(/wd4127)
	# disable: warning C4512: '***' : assignment operator could not be generated
	add_definitions(/wd4512)
	# disable: warning C4275: non dll-interface class '***' used as base for dll-interface clas '***'
	add_definitions(/wd4275)

	if (CMAKE_CXX_FLAGS MATCHES "/W[0-4]")
		STRING(REGEX REPLACE "/W[0-4]" "${WARNING_LEVEL}" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
	else ()
		SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${WARNING_LEVEL}")
	endif ()

endif ()

cmake_dependent_option(MYGUI_BUILD_DOCS "Generate documentation" TRUE "DOXYGEN_FOUND" FALSE)

# global configs
include_directories(
	${MYGUI_SOURCE_DIR}/MyGUIEngine/include
)

###################################################################
# configure global build settings based on selected build options
###################################################################
include(ConfigureBuild)


##################################################################
# Now setup targets
##################################################################

# install resource files
include(InstallResources)

# Setup MyGUIEngine project
add_subdirectory(MyGUIEngine)

# Setup Platforms
add_subdirectory(Platforms)

if (MYGUI_BUILD_DEMOS OR MYGUI_BUILD_TOOLS OR MYGUI_BUILD_UNITTESTS OR MYGUI_BUILD_TEST_APP)
	add_subdirectory(Common)
endif ()

# Setup Plugins
if (MYGUI_BUILD_PLUGINS)
	add_subdirectory(Plugins)
endif ()

if (MYGUI_BUILD_DEMOS)

=== Common/CMakeLists.txt ===
function(mygui_add_base_manager_include PLATFORM_ID)
	mygui_set_platform_name(${PLATFORM_ID})
	include_directories(../../Common/Base/${MYGUI_PLATFORM_NAME})
endfunction(mygui_add_base_manager_include)

set (PROJECTNAME Common)

include_directories(
	.
	${MYGUI_SOURCE_DIR}/Common
	${MYGUI_SOURCE_DIR}/MyGUIEngine/include
)

set (HEADER_FILES "")
set (SOURCE_FILES "")

include_directories(SYSTEM ${SDL2_INCLUDE_DIRS})
link_directories(${SDL2_LIB_DIR})

mygui_set_platform_name(${MYGUI_RENDERSYSTEM})
set (HEADER_FILES ${HEADER_FILES} Base/${MYGUI_PLATFORM_NAME}/BaseManager.h Base/PlatformBaseManager/SdlBaseManager.h)
set (SOURCE_FILES ${SOURCE_FILES} Base/${MYGUI_PLATFORM_NAME}/BaseManager.cpp Base/PlatformBaseManager/SdlBaseManager.cpp)
SOURCE_GROUP("Base" FILES
	Base/${MYGUI_PLATFORM_NAME}/BaseManager.h
	Base/${MYGUI_PLATFORM_NAME}/BaseManager.cpp
	Base/PlatformBaseManager/SdlBaseManager.h
	Base/PlatformBaseManager/SdlBaseManager.cpp
)
include_directories(
	${MYGUI_SOURCE_DIR}/Platforms/${MYGUI_PLATFORM_NAME}/${MYGUI_PLATFORM_NAME}Platform/include
)
if(MYGUI_RENDERSYSTEM EQUAL 1)
	add_definitions("-DMYGUI_DUMMY_PLATFORM")
	link_directories(${DUMMY_LIB_DIR})
elseif(MYGUI_RENDERSYSTEM EQUAL 3)
	add_definitions("-DMYGUI_OGRE_PLATFORM")
	include_directories(SYSTEM
		${OGRE_INCLUDE_DIR}
	)
	link_directories(${OGRE_LIB_DIR})
elseif(MYGUI_RENDERSYSTEM EQUAL 4)
	add_definitions("-DMYGUI_OPENGL_PLATFORM")
	include_directories(SYSTEM
		${OPENGL_INCLUDE_DIR}
		${SDL2_IMAGE_INCLUDE_DIRS}
		${MYGUI_SOURCE_DIR}/Platforms/${MYGUI_PLATFORM_NAME}/${MYGUI_PLATFORM_NAME}Platform/include
	)
	include_directories(SYSTEM include/GL)
	link_directories(${OPENGL_LIB_DIR})
	link_directories(${SDL2_IMAGE_LIB_DIR})
elseif(MYGUI_RENDERSYSTEM EQUAL 5)
	add_definitions("-DMYGUI_DIRECTX_PLATFORM")
	include_directories(SYSTEM
		${DirectX_INCLUDE_DIR}
	)
	link_directories(${DIRECTX_LIB_DIR})
elseif(MYGUI_RENDERSYSTEM EQUAL 6)
	add_definitions("-DMYGUI_DIRECTX11_PLATFORM")
	include_directories(SYSTEM
		${DirectX_INCLUDE_DIR}
	)
	link_directories(${DIRECTX_LIB_DIR})
elseif(MYGUI_RENDERSYSTEM EQUAL 7)
	add_definitions("-DMYGUI_OPENGL3_PLATFORM")
	include_directories(SYSTEM
		${OPENGL_INCLUDE_DIR}
		${SDL2_IMAGE_INCLUDE_DIRS}
		${MYGUI_SOURCE_DIR}/Platforms/${MYGUI_PLATFORM_NAME}/${MYGUI_PLATFORM_NAME}Platform/include
	)
	link_directories(${OPENGL_LIB_DIR})
	link_directories(${SDL2_IMAGE_LIB_DIR})
elseif(MYGUI_RENDERSYSTEM EQUAL 8)
	add_definitions("-DMYGUI_OPENGLES_PLATFORM")
	include_directories(SYSTEM
		${OPENGL_INCLUDE_DIR}
		${SDL2_IMAGE_INCLUDE_DIRS}
	)
	link_directories(${OPENGL_LIB_DIR})
	link_directories(${SDL2_IMAGE_LIB_DIR})
endif()

include_directories(Input/SDL)
set (HEADER_FILES ${HEADER_FILES}
	Input/SDL/InputManager.h
	Input/SDL/PointerManager.h
	)
set (SOURCE_FILES ${SOURCE_FILES}
	Input/SDL/InputManager.cpp
	Input/SDL/PointerManager.cpp
	)
SOURCE_GROUP("Base" FILES
	Input/SDL/InputManager.h
	Input/SDL/InputManager.cpp
	Input/SDL/PointerManager.h
	Input/SDL/PointerManager.cpp
)

add_library(${PROJECTNAME} ${HEADER_FILES} ${SOURCE_FILES})

mygui_set_platform_name(${MYGUI_RENDERSYSTEM})
add_dependencies(${PROJECTNAME} MyGUI.${MYGUI_PLATFORM_NAME}Platform)
target_link_libraries(${PROJECTNAME} MyGUI.${MYGUI_PLATFORM_NAME}Platform)

add_dependencies(${PROJECTNAME} MyGUIEngine)

=== Media/CMakeLists.txt ===
###############################################################
# Install media
###############################################################

# Set media target directory
if (WIN32)
  set(MYGUI_MEDIA_PATH "Media")
elseif (UNIX)
  set(MYGUI_MEDIA_PATH "share/MYGUI/Media")
elseif (APPLE)
  # TODO
endif ()

install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/
  DESTINATION ${MYGUI_MEDIA_PATH}
  PATTERN ".svn" EXCLUDE
  PATTERN "CMakeLists.txt" EXCLUDE
  PATTERN "vector" EXCLUDE
)

=== Platforms/CMakeLists.txt ===
mygui_set_platform_name(${MYGUI_RENDERSYSTEM})

add_subdirectory(${MYGUI_PLATFORM_NAME}/${MYGUI_PLATFORM_NAME}Platform)

=== Demos/Demo_ScrollView/CMakeLists.txt ===
mygui_demo(Demo_ScrollView)

=== Plugins/Plugin_StrangeButton/CMakeLists.txt ===
mygui_plugin(Plugin_StrangeButton)

=== Tools/EditorFramework/CMakeLists.txt ===
mygui_tool_dll(EditorFramework)
set_source_files_properties(pugixml.cpp PROPERTIES COMPILE_FLAGS -w)

=== Tools/ImageEditor/CMakeLists.txt ===
mygui_tool(ImageEditor)

=== UnitTests/UnitTest_ChildAttach/CMakeLists.txt ===
mygui_unit_test(UnitTest_ChildAttach)

=== Platforms/DirectX/DirectXPlatform/CMakeLists.txt ===
set(PROJECTNAME MyGUI.DirectXPlatform)

include_directories(
	include
	${MYGUI_SOURCE_DIR}/MyGUIEngine/include
	${DirectX_INCLUDE_DIR}
	${MYGUI_SOURCE_DIR}/Common
)

include(${PROJECTNAME}.list)

add_library(${PROJECTNAME} ${HEADER_FILES} ${SOURCE_FILES})

add_dependencies(${PROJECTNAME} MyGUIEngine)

target_link_libraries(${PROJECTNAME} ${DirectX_LIBRARIES} MyGUIEngine)
link_directories(${DirectX_LIBRARY_DIRS})

# installation rules
install(FILES ${HEADER_FILES}
	DESTINATION include/MYGUI
)
mygui_install_target(${PROJECTNAME} "")

=== Platforms/DirectX11/DirectX11Platform/CMakeLists.txt ===
set(PROJECTNAME MyGUI.DirectX11Platform)

include_directories(
	include
	${MYGUI_SOURCE_DIR}/MyGUIEngine/include
	${DirectX_INCLUDE_DIR}
	${MYGUI_SOURCE_DIR}/Common
)

include(${PROJECTNAME}.list)

add_library(${PROJECTNAME} ${HEADER_FILES} ${SOURCE_FILES})

add_dependencies(${PROJECTNAME} MyGUIEngine)

target_link_libraries(${PROJECTNAME} ${DirectX11_LIBRARIES} MyGUIEngine)
link_directories(${DirectX_LIBRARY_DIRS})

# installation rules
install(FILES ${HEADER_FILES}
	DESTINATION include/MYGUI
)
mygui_install_target(${PROJECTNAME} "")

=== Platforms/Dummy/DummyPlatform/CMakeLists.txt ===
set(PROJECTNAME MyGUI.DummyPlatform)

include_directories(
	include
	${MYGUI_SOURCE_DIR}/MyGUIEngine/include
	${MYGUI_SOURCE_DIR}/Common
)

include(${PROJECTNAME}.list)

add_library(${PROJECTNAME} ${HEADER_FILES} ${SOURCE_FILES})

add_dependencies(${PROJECTNAME} MyGUIEngine)

target_link_libraries(${PROJECTNAME} MyGUIEngine)

# installation rules
install(FILES ${HEADER_FILES}
	DESTINATION include/MYGUI
)
mygui_install_target(${PROJECTNAME} "")

=== debian/changelog ===
mygui (3.4.1+dfsg-3) unstable; urgency=medium

  * Team upload
  * libmygui-dev: Add missing Depends (Closes: #1035453)

 -- Bastian Germann <bage@debian.org>  Fri, 12 May 2023 19:29:44 +0200

mygui (3.4.1+dfsg-2) unstable; urgency=medium

  * Team upload
  * Let uscan repack automatically

  [ Bret Curtis ]
  * Make this a team-maintained package

 -- Bastian Germann <bage@debian.org>  Tue, 06 Sep 2022 18:22:04 +0200

mygui (3.4.1+dfsg-1) unstable; urgency=medium

  [ Bret Curtis ]
  * New upstream release (3.4.1)
  * Stripped windows binaries from source, making it dfsg
  * Added new OpenGL3 rendering target
  * Updated symbols files

  [ Steve Langesek ]
  * Resolved ftbfs with GCC-11 (Closes: #984248)

  [ Debian Janitor ]
  * Trim trailing whitespace.
  * Set upstream metadata fields: Bug-Database, Bug-Submit.
  * Use canonical URL in Vcs-Git.
  * Remove unnecessary get-orig-source-target.  

 -- Bret Curtis <psi29a@gmail.com>  Tue, 02 Mar 2021 13:30:43 +0100

=== debian/control ===
Source: mygui
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Bret Curtis <psi29a@gmail.com>
Build-Depends: cmake, doxygen, debhelper-compat (= 13), g++ (>= 4:7),
 libogre-1.12-dev, pkg-kde-tools, libfreetype6-dev (>= 2.5.1),
 pkg-config, graphviz, libgl1-mesa-dev, libglew-dev, libois-dev
Homepage: http://www.ogre3d.org/tikiwiki/MyGUI
Standards-Version: 4.5.1
Section: libs
Vcs-Browser: https://salsa.debian.org/games-team/mygui
Vcs-Git: https://salsa.debian.org/games-team/mygui.git

Package: libmygui-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends},
 libmyguiengine3debian1v5 (= ${binary:Version}),
 libmygui.ogreplatform0debian1v5 (= ${binary:Version}),
 libmygui.opengl3platform0debian1v5 (= ${binary:Version}),
 libmygui.openglplatform0debian1v5 (= ${binary:Version})
Suggests: mygui-doc
Description: Fast, simple and flexible GUI for OpenMW - development files
 MyGUI is a GUI library which aims to be fast, flexible and simple GUIs in C++.
  Features include
    Layout Editor.
    Multicolour text.
    Per pixel cut.
    Changing alpha support for widgets (also in states configuration).
    Interface localisation.
    Fast RTTI for safe casts.
    Tool tips.
    Animated cursors and pictures.
    User xml resources.
    Truetype fonts and fonts from texture.
    Widgets controllers (moving, fading and so on).
    Flexible configuration in xml config file.
    Subskins with tiling, with direct access to texture.
    Possibility to store any data in widgets items.
    Skin themes.
    Wrappers for fast UI development.
    Drag'n'drop.
 .
 This package contains the headers and static libraries needed to develop
 programs using MyGUI.

Package: libmyguiengine3debian1v5
Architecture: any
Conflicts: libmyguiengine3debian1
Replaces: libmyguiengine3debian1
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Fast, simple and flexible GUI - shared library
 MyGUI is a GUI library which aims to be fast, flexible and simple GUIs in C++.
  Features include
    Layout Editor.
    Multicolour text.
    Per pixel cut.
    Changing alpha support for widgets (also in states configuration).
    Interface localisation.
    Fast RTTI for safe casts.
    Tool tips.
    Animated cursors and pictures.
    User xml resources.
    Truetype fonts and fonts from texture.
    Widgets controllers (moving, fading and so on).
    Flexible configuration in xml config file.
    Subskins with tiling, with direct access to texture.
    Possibility to store any data in widgets items.
    Skin themes.
    Wrappers for fast UI development.
    Drag'n'drop.
 .
 This package contains the MyGUI runtime engine.

Package: libmygui.ogreplatform0debian1v5
Architecture: any
Conflicts: libmygui.ogreplatform0debian1
Replaces: libmygui.ogreplatform0debian1
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Fast, simple and flexible GUI - Ogre interface
 MyGUI is a GUI library which aims to be fast, flexible and simple GUIs in C++.
  Features include
    Layout Editor.
    Multicolour text.
    Per pixel cut.
    Changing alpha support for widgets (also in states configuration).
    Interface localisation.
    Fast RTTI for safe casts.
    Tool tips.
    Animated cursors and pictures.
    User xml resources.
    Truetype fonts and fonts from texture.
    Widgets controllers (moving, fading and so on).
    Flexible configuration in xml config file.
    Subskins with tiling, with direct access to texture.
    Possibility to store any data in widgets items.
    Skin themes.
    Wrappers for fast UI development.
    Drag'n'drop.
 .
 This package contains the MyGUI interface to the Ogre graphics engine.

Package: libmygui.openglplatform0debian1v5
Architecture: any
Conflicts: libmygui.openglplatform0debian1
Replaces: libmygui.openglplatform0debian1
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Fast, simple and flexible GUI - OpenGL interface
 MyGUI is a GUI library which aims to be fast, flexible and simple GUIs in C++.
  Features include
    Layout Editor.
    Multicolour text.
    Per pixel cut.
    Changing alpha support for widgets (also in states configuration).
    Interface localisation.
    Fast RTTI for safe casts.
    Tool tips.
    Animated cursors and pictures.
    User xml resources.
    Truetype fonts and fonts from texture.
    Widgets controllers (moving, fading and so on).
    Flexible configuration in xml config file.
    Subskins with tiling, with direct access to texture.
    Possibility to store any data in widgets items.
    Skin themes.
    Wrappers for fast UI development.
    Drag'n'drop.
 .
 This package contains the MyGUI interface for OpenGL.

Package: libmygui.opengl3platform0debian1v5
Architecture: any
Conflicts: libmygui.opengl3platform0debian1
Replaces: libmygui.opengl3platform0debian1
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Fast, simple and flexible GUI - OpenGL3 interface
 MyGUI is a GUI library which aims to be fast, flexible and simple GUIs in C++.
  Features include
    Layout Editor.
    Multicolour text.
    Per pixel cut.
    Changing alpha support for widgets (also in states configuration).
    Interface localisation.
    Fast RTTI for safe casts.
    Tool tips.
    Animated cursors and pictures.
    User xml resources.
    Truetype fonts and fonts from texture.
    Widgets controllers (moving, fading and so on).
    Flexible configuration in xml config file.
    Subskins with tiling, with direct access to texture.
    Possibility to store any data in widgets items.
    Skin themes.
    Wrappers for fast UI development.
    Drag'n'drop.
 .
 This package contains the MyGUI interface for OpenGL3.

Package: mygui-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}, libjs-jquery
Description: API documentations for MyGUI library
 MyGUI is a GUI library which aims to be fast, flexible and simple GUIs in C++.
  Features include
    Layout Editor.
    Multicolour text.
    Per pixel cut.
    Changing alpha support for widgets (also in states configuration).
    Interface localisation.
    Fast RTTI for safe casts.
    Tool tips.
    Animated cursors and pictures.
    User xml resources.
    Truetype fonts and fonts from texture.
    Widgets controllers (moving, fading and so on).
    Flexible configuration in xml config file.
    Subskins with tiling, with direct access to texture.
    Possibility to store any data in widgets items.
    Skin themes.
    Wrappers for fast UI development.
    Drag'n'drop.
 .
 This package contains the MyGUI API reference for the MyGUIEngine library.

=== debian/watch ===
version=3
opts=repacksuffix=+dfsg,dversionmangle=s/(\da?)[\+\.\-~](?:dfsg|debian|ds|repack|repacked)\.?\d*$/$1/ \
https://github.com/MyGUI/mygui/releases .*/MyGUI([\d\.]*)\.tar.gz

## mygui 3.4.2+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,9 +6,9 @@
 ######################################################################
 
 cmake_minimum_required(VERSION 2.8.12)
-cmake_policy(SET CMP0003 NEW)
-cmake_policy(SET CMP0011 NEW)
-cmake_policy(SET CMP0048 OLD)
+if(POLICY CMP0048)
+	cmake_policy(SET CMP0048 NEW)
+endif()
 
 # for link time optimization, remove if cmake version is >= 3.9
 if(POLICY CMP0069) # LTO
@@ -37,6 +37,8 @@
 
 SET(CMAKE_CXX_STANDARD 11)
 set(CMAKE_EXPORT_COMPILE_COMMANDS True)
+# Prevent CMake from adding "#pragma clang system_header" to the precompiled headers (otherwise all warnings are suppressed)
+set(CMAKE_PCH_PROLOGUE "")
 
 #####################################################################
 # Set up the basic build environment
@@ -160,7 +162,6 @@
 cmake_dependent_option(MYGUI_INSTALL_DEMOS "Install MyGUI demos." FALSE "MYGUI_BUILD_DEMOS" FALSE)
 cmake_dependent_option(MYGUI_INSTALL_TOOLS "Install MyGUI tools." FALSE "MYGUI_BUILD_TOOLS" FALSE)
 option(MYGUI_INSTALL_DOCS "Install documentation." FALSE)
-option(MYGUI_INSTALL_MEDIA "Install media files." FALSE)
 cmake_dependent_option(MYGUI_INSTALL_PDB "Install debug pdb files" FALSE "MSVC;NOT MYGUI_STATIC" FALSE)
 option(MYGUI_STANDALONE_BUILD "Generate build files that do not reference CMake (should be used only from Scripts/prepareRelease.py)" FALSE)
 MARK_AS_ADVANCED(MYGUI_STANDALONE_BUILD)
@@ -169,6 +170,7 @@
 
 if (MSVC)
 	option(MYGUI_USE_PROJECT_FOLDERS "Use Visual Studio solution folders for projects." TRUE)
+	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /Zc:__cplusplus")
 endif ()
 
 # Used to not annoy users with high level warnings (should be TRUE for developers)
@@ -188,28 +190,60 @@
 
 # Set compiler specific build flags
 if (CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang" OR CMAKE_CXX_COMPILER_ID MATCHES "Intel")
+	add_compile_options(-Werror)
 	if (NOT MYGUI_HIGH_LEVEL_WARNINGS)
-		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -w")
+		add_compile_options(-w)
 	else ()
 		if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
-			set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Weverything")
+			add_compile_options(
+				-Weverything
+			)
 			# might be useful
-			set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-documentation-unknown-command -Wno-unknown-warning-option -Wno-sign-conversion -Wno-conversion -Wno-documentation -Wno-old-style-cast")
-			set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-poison-system-directories")
+			add_compile_options(
+				-Wno-reorder
+			)
 			# not useful
-			set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-missing-prototypes -Wno-reorder -Wno-c++98-compat-pedantic -Wno-c++11-extensions -Wno-float-equal -Wno-padded -Wno-weak-vtables -Wno-duplicate-enum -Wno-exit-time-destructors -Wno-unused-parameter -Wno-global-constructors")
+			add_compile_options(
+				-Wno-unknown-warning-option
+				-Wno-documentation
+				-Wno-documentation-unknown-command
+				-Wno-conversion
+				-Wno-old-style-cast
+				-Wno-poison-system-directories
+				-Wno-c++98-compat-pedantic
+				-Wno-c++11-extensions
+				-Wno-float-equal
+				-Wno-padded
+				-Wno-weak-vtables
+				-Wno-duplicate-enum
+				-Wno-exit-time-destructors
+				-Wno-unused-parameter
+				-Wno-global-constructors
+			)
 		else ()
-			# very interesting option, but way too many warnings
-			#add_definitions(-Weffc++)
-			set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-deprecated -Wall -Wno-reorder -Winit-self -Woverloaded-virtual -Wcast-qual -Wwrite-strings -Wextra -Wno-unused-parameter")
-			set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pedantic")
+			# TODO: the warnings below have'nt been checked for a while
+			add_compile_options(
+				-Wno-deprecated
+				-Wall
+				-Wno-reorder
+				-Winit-self
+				-Woverloaded-virtual
+				-Wcast-qual
+				-Wwrite-strings
+				-Wextra
+				-pedantic
+			)
 			if (NOT CMAKE_CXX_COMPILER_ID MATCHES "Intel")
-				set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wctor-dtor-privacy")
-				set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fdiagnostics-show-option")
+				add_compile_definitions(-Wctor-dtor-privacy)
+				add_compile_definitions(-fdiagnostics-show-option)
 			endif ()
+			# disable some
+			add_compile_definitions(
+				-Wno-unused-parameter
+			)
 
 			# MyGUI_UString.h ignored from warnings because of this
-			set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wshadow")
+			add_compile_definitions(-Wshadow)
 		endif ()
 	endif ()
 endif ()
@@ -219,8 +253,8 @@
 	# UBSAN_OPTIONS=print_stacktrace=1,suppressions=sanitizers/UBSanitizer.supp <command>
 	option(MYGUI_UB_SANITIZER "Compile with undefined behaviour sanitizer" FALSE)
 	if (MYGUI_UB_SANITIZER)
-		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-omit-frame-pointer -fno-optimize-sibling-calls")
-		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=undefined -fno-sanitize-recover=undefined")
+		add_compile_definitions(-fno-omit-frame-pointer -fno-optimize-sibling-calls)
+		add_compile_definitions(-fsanitize=undefined -fno-sanitize-recover=undefined)
 	endif()
 
 	# usage:
@@ -228,8 +262,8 @@
 	# alloc_dealloc_mismatch is here due to issues with Ogre and no clear way to suppress the issue
 	option(MYGUI_ADDRESS_SANITIZER "Compile with address sanitizer" FALSE)
 	if (MYGUI_ADDRESS_SANITIZER)
-		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-omit-frame-pointer -fno-optimize-sibling-calls")
-		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address -fsanitize-address-use-after-scope")
+		add_compile_definitions(-fno-omit-frame-pointer -fno-optimize-sibling-calls)
+		add_compile_definitions(-fsanitize=address -fsanitize-address-use-after-scope)
 	endif()
 endif ()
 
@@ -244,17 +278,15 @@
 	endif ()
 	# disable: warning C4100: '***' : unreferenced formal parameter
 	add_definitions(/wd4100)
-	# disable: warning C4127: conditional expression is constant
-	add_definitions(/wd4127)
-	# disable: warning C4512: '***' : assignment operator could not be generated
-	add_definitions(/wd4512)
+
+	# TODO: move to Tools only
 	# disable: warning C4275: non dll-interface class '***' used as base for dll-interface clas '***'
 	add_definitions(/wd4275)
 
 	if (CMAKE_CXX_FLAGS MATCHES "/W[0-4]")
 		STRING(REGEX REPLACE "/W[0-4]" "${WARNING_LEVEL}" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
 	else ()
-		SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${WARNING_LEVEL}")
+		add_compile_definitions(${WARNING_LEVEL})
 	endif ()
 
 endif ()
@@ -295,3 +327,17 @@
 endif ()
 
 if (MYGUI_BUILD_DEMOS)
+	add_subdirectory(Demos)
+endif ()
+
+# Setup command-line tools
+if (MYGUI_BUILD_TOOLS)
+	add_subdirectory(Tools)
+endif ()
+
+# Setup tests
+if (MYGUI_BUILD_UNITTESTS OR MYGUI_BUILD_TEST_APP)
+	add_subdirectory(UnitTests)
+endif ()
+
+# Setup wrapers

=== Common/CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 	include_directories(../../Common/Base/${MYGUI_PLATFORM_NAME})
 endfunction(mygui_add_base_manager_include)
 
-set (PROJECTNAME Common)
+set (PROJECTNAME MyGUICommon)
 
 include_directories(
 	.
@@ -99,6 +99,10 @@
 
 mygui_set_platform_name(${MYGUI_RENDERSYSTEM})
 add_dependencies(${PROJECTNAME} MyGUI.${MYGUI_PLATFORM_NAME}Platform)
-target_link_libraries(${PROJECTNAME} MyGUI.${MYGUI_PLATFORM_NAME}Platform)
+target_link_libraries(${PROJECTNAME} MyGUI.${MYGUI_PLATFORM_NAME}Platform SDL2::Main)
+if (MYGUI_INSTALL_TOOLS OR MYGUI_INSTALL_DEMOS)
+	set_target_properties(${PROJECTNAME} PROPERTIES VERSION ${MYGUI_VERSION} SOVERSION "${MYGUI_VERSION_MAJOR}.${MYGUI_VERSION_MINOR}.${MYGUI_VERSION_PATCH}")
+	mygui_install_target(${PROJECTNAME} "")
+endif()
 
 add_dependencies(${PROJECTNAME} MyGUIEngine)

=== MyGUIEngine/CMakeLists.txt ===
set (PROJECTNAME MyGUIEngine)

project( ${PROJECTNAME} )

include(${PROJECTNAME}.list)

include_directories(include)
if (MYGUI_USE_FREETYPE)
	include_directories(SYSTEM
		${FREETYPE_INCLUDE_DIRS}
	)
	add_definitions(-DMYGUI_USE_FREETYPE)

	if (MYGUI_MSDF_FONTS)
		add_definitions(-DMYGUI_MSDF_FONTS)
	endif ()
endif ()
if (MYGUI_DISABLE_PLUGINS)
	add_definitions(-DMYGUI_DISABLE_PLUGINS)
endif ()

add_definitions(-DMYGUI_BUILD)

# setup MyGUIEngine target
add_library(${PROJECTNAME} ${MYGUI_LIB_TYPE} ${HEADER_FILES} ${SOURCE_FILES})
if (NOT ANDROID)
	set_target_properties(${PROJECTNAME} PROPERTIES VERSION ${MYGUI_VERSION} SOVERSION "${MYGUI_VERSION_MAJOR}.${MYGUI_VERSION_MINOR}.${MYGUI_VERSION_PATCH}")
endif()

if (UNIX)
	# some platforms require explicit linking to libdl, see if it's available
	find_library(DL_LIBRARY NAMES dl dlsym)
	mark_as_advanced(DL_LIBRARY)
	if (DL_LIBRARY)
		target_link_libraries(${PROJECTNAME} dl)
	endif ()
endif()

if (MYGUI_USE_FREETYPE)
	if (MYGUI_MSDF_FONTS)
		add_subdirectory(src/msdfgen)
		target_link_libraries(${PROJECTNAME} msdfgen)
	endif ()

	target_link_libraries(${PROJECTNAME} ${FREETYPE_LIBRARIES})
	if (ZLIB_FOUND) # hacky way to check if freetype was built with zlib
		target_link_libraries(${PROJECTNAME} ${ZLIB_LIBRARIES})
	endif()
endif()

if (${CMAKE_VERSION} VERSION_EQUAL "3.16" OR ${CMAKE_VERSION} VERSION_GREATER "3.16")
	target_precompile_headers(${PROJECTNAME} PRIVATE "${CMAKE_CURRENT_SOURCE_DIR}/include/MyGUI_Precompiled.h")
endif ()

set(${PROJECTNAME}_HEADERS ${HEADER_FILES}) # for Mac OS X
mygui_config_lib(${PROJECTNAME})

# install MyGUIEngine headers
install(FILES ${HEADER_FILES}
  DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/MYGUI"
)

=== Tools/CMakeLists.txt ===
add_subdirectory(EditorFramework)
add_subdirectory(LayoutEditor)
add_subdirectory(SkinEditor)
add_subdirectory(ImageEditor)
add_subdirectory(FontEditor)

=== Demos/Demo_Console/CMakeLists.txt ===
mygui_demo(Demo_Console)

=== Demos/Demo_Picking/CMakeLists.txt ===
mygui_demo(Demo_Picking)

=== Demos/Demo_PluginBerkeliumWidget/CMakeLists.txt ===
find_package(Berkelium)
if (BERKELIUM_FOUND)
else ()
	message (FATAL_ERROR "Could not find Berkelium")
endif ()

include_directories(${MYGUI_SOURCE_DIR}/Plugins/Plugin_BerkeliumWidget ${BERKELIUM_INCLUDE_DIRS})
mygui_demo(Demo_PluginBerkeliumWidget)
add_dependencies(Demo_PluginBerkeliumWidget Plugin_BerkeliumWidget)
target_link_libraries(Demo_PluginBerkeliumWidget ${BERKELIUM_LIBRARIES})
target_link_libraries(Demo_PluginBerkeliumWidget Plugin_BerkeliumWidget)
link_directories(${BERKELIUM_LIBRARY_DIRS})

=== Wrappers/MyGUI_OgrePlatform_Export/CMakeLists.txt ===
#only for ogre
if(MYGUI_RENDERSYSTEM EQUAL 3)

	function(mygui_orge_platform_export PROJECTNAME SOLUTIONFOLDER)
		include_directories(
			.
			#${MYGUI_SOURCE_DIR}/Common
			${MYGUI_SOURCE_DIR}/MyGUIEngine/include
		)
		# define the sources
		include(${PROJECTNAME}.list)
		include_directories(
			${MYGUI_SOURCE_DIR}/Platforms/Ogre/OgrePlatform/include
			${OGRE_INCLUDE_DIR}
		)
		link_directories(${OGRE_LIB_DIR})
		add_library(${PROJECTNAME} ${MYGUI_LIB_TYPE} ${HEADER_FILES} ${SOURCE_FILES})
		set_target_properties(${PROJECTNAME} PROPERTIES FOLDER ${SOLUTIONFOLDER})
		
		# add dependencies
		add_dependencies(${PROJECTNAME} MyGUIEngine )

		# link libraries against it
		target_link_libraries(${PROJECTNAME}
			MyGUIEngine
		#	uuid
		)

		# add dependencies
		add_dependencies(${PROJECTNAME} MyGUIEngine)
		add_dependencies(${PROJECTNAME} MyGUI.OgrePlatform)
		target_link_libraries(${PROJECTNAME} MyGUI.OgrePlatform)
	endfunction(mygui_orge_platform_export)

	mygui_orge_platform_export(MyGUI_OgrePlatform_Export Wrappers)

endif()

=== Wrappers/MyGUI_RenderWindow_Export/CMakeLists.txt ===
mygui_app(MyGUI_RenderWindow_Export Wrappers)

=== Platforms/DirectX/DirectXPlatform/CMakeLists.txt ===
--- 
+++ 
@@ -18,6 +18,6 @@
 
 # installation rules
 install(FILES ${HEADER_FILES}
-	DESTINATION include/MYGUI
+	DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/MYGUI"
 )
 mygui_install_target(${PROJECTNAME} "")

=== Platforms/Dummy/DummyPlatform/CMakeLists.txt ===
--- 
+++ 
@@ -16,6 +16,6 @@
 
 # installation rules
 install(FILES ${HEADER_FILES}
-	DESTINATION include/MYGUI
+	DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/MYGUI"
 )
 mygui_install_target(${PROJECTNAME} "")

=== Platforms/OpenGL/OpenGLPlatform/CMakeLists.txt ===
set(PROJECTNAME MyGUI.OpenGLPlatform)

include_directories(
	include
	${MYGUI_SOURCE_DIR}/MyGUIEngine/include
	${OPENGL_INCLUDE_DIR}
	${MYGUI_SOURCE_DIR}/Common
)

include_directories(SYSTEM include/GL)

include(${PROJECTNAME}.list)
if (NOT MYGUI_USE_SYSTEM_GLEW)
	set(SOURCE_FILES ${SOURCE_FILES} include/GL/glew.c)
endif ()

if (NOT MYGUI_USE_SYSTEM_GLEW)
	add_definitions(-DGLEW_STATIC)
endif ()
add_definitions(-DGL_GLEXT_PROTOTYPES)

add_library(${PROJECTNAME} ${HEADER_FILES} ${SOURCE_FILES})

add_dependencies(${PROJECTNAME} MyGUIEngine)

if (APPLE)
	target_link_libraries(${PROJECTNAME} ${OPENGL_gl_LIBRARY} MyGUIEngine)
else ()
	# opengl instead of gl makes it compile and work in a libX11-free wayland setup
	target_link_libraries(${PROJECTNAME} ${OPENGL_opengl_LIBRARY} MyGUIEngine)
endif ()
if (MYGUI_USE_SYSTEM_GLEW)
	target_link_libraries(${PROJECTNAME} ${GLEW_LIBRARIES})
else ()
	target_link_libraries(${PROJECTNAME} ${OPENGL_glx_LIBRARY})
endif ()

link_directories(${OPENGL_LIB_DIR})

# installation rules
install(FILES ${HEADER_FILES}
	DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/MYGUI"
)
mygui_install_target(${PROJECTNAME} "")

if (MYGUI_HIGH_LEVEL_WARNINGS)
	if (NOT MSVC)
		set_source_files_properties(${SOURCE_FILES} PROPERTIES COMPILE_FLAGS -Wno-reserved-id-macro)
		set_source_files_properties(include/GL/glew.c PROPERTIES COMPILE_FLAGS -w)
	endif ()
endif ()

=== debian/changelog ===
mygui (3.4.2+dfsg-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1063154

 -- Benjamin Drung <bdrung@debian.org>  Wed, 28 Feb 2024 21:40:30 +0000

mygui (3.4.2+dfsg-1) unstable; urgency=medium

  * Team upload.

  [ Bret Curtis ]
  * Import new upstream version 3.4.2.
  * Update patch file.
  * Fix uscan to scan GitHub tags.
  * Move Build-Depends to libfreetype-dev and libgl-dev.

  [ Debian Janitor ]
  * Remove constraints unnecessary since buster (oldstable):
    + Build-Depends: Drop versioned constraint on g++ and libfreetype6-dev.
  * Trim trailing whitespace.
  * Set upstream metadata fields: Archive, Repository-Browse.
  * Update standards version to 4.6.1, no changes needed.

 -- Bastian Germann <bage@debian.org>  Mon, 12 Jun 2023 15:30:17 +0200

=== debian/control ===
--- 
+++ 
@@ -2,11 +2,11 @@
 Priority: optional
 Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
 Uploaders: Bret Curtis <psi29a@gmail.com>
-Build-Depends: cmake, doxygen, debhelper-compat (= 13), g++ (>= 4:7),
- libogre-1.12-dev, pkg-kde-tools, libfreetype6-dev (>= 2.5.1),
- pkg-config, graphviz, libgl1-mesa-dev, libglew-dev, libois-dev
+Build-Depends: dpkg-dev (>= 1.22.5), cmake, doxygen, debhelper-compat (= 13),
+ libogre-1.12-dev, pkg-kde-tools, libfreetype-dev,
+ pkg-config, graphviz, libgl-dev, libglew-dev, libois-dev
 Homepage: http://www.ogre3d.org/tikiwiki/MyGUI
-Standards-Version: 4.5.1
+Standards-Version: 4.6.1
 Section: libs
 Vcs-Browser: https://salsa.debian.org/games-team/mygui
 Vcs-Git: https://salsa.debian.org/games-team/mygui.git
@@ -15,10 +15,10 @@
 Section: libdevel
 Architecture: any
 Depends: ${misc:Depends},
- libmyguiengine3debian1v5 (= ${binary:Version}),
- libmygui.ogreplatform0debian1v5 (= ${binary:Version}),
- libmygui.opengl3platform0debian1v5 (= ${binary:Version}),
- libmygui.openglplatform0debian1v5 (= ${binary:Version})
+ libmyguiengine3debian1t64 (= ${binary:Version}),
+ libmygui.ogreplatform0debian1t64 (= ${binary:Version}),
+ libmygui.opengl3platform0debian1t64 (= ${binary:Version}),
+ libmygui.openglplatform0debian1t64 (= ${binary:Version})
 Suggests: mygui-doc
 Description: Fast, simple and flexible GUI for OpenMW - development files
  MyGUI is a GUI library which aims to be fast, flexible and simple GUIs in C++.
@@ -44,10 +44,13 @@
  This package contains the headers and static libraries needed to develop
  programs using MyGUI.
 
-Package: libmyguiengine3debian1v5
+Package: libmyguiengine3debian1t64
+Provides: ${t64:Provides}
+X-Time64-Compat: libmyguiengine3debian1v5
+Breaks: libmyguiengine3debian1v5 (<< ${source:Version})
 Architecture: any
 Conflicts: libmyguiengine3debian1
-Replaces: libmyguiengine3debian1
+Replaces: libmyguiengine3debian1v5, libmyguiengine3debian1
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: Fast, simple and flexible GUI - shared library
  MyGUI is a GUI library which aims to be fast, flexible and simple GUIs in C++.
@@ -72,10 +75,13 @@
  .
  This package contains the MyGUI runtime engine.
 
-Package: libmygui.ogreplatform0debian1v5
+Package: libmygui.ogreplatform0debian1t64
+Provides: ${t64:Provides}
+X-Time64-Compat: libmygui.ogreplatform0debian1v5
+Breaks: libmygui.ogreplatform0debian1v5 (<< ${source:Version})
 Architecture: any
 Conflicts: libmygui.ogreplatform0debian1
-Replaces: libmygui.ogreplatform0debian1
+Replaces: libmygui.ogreplatform0debian1v5, libmygui.ogreplatform0debian1
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: Fast, simple and flexible GUI - Ogre interface
  MyGUI is a GUI library which aims to be fast, flexible and simple GUIs in C++.
@@ -100,10 +106,13 @@
  .
  This package contains the MyGUI interface to the Ogre graphics engine.
 
-Package: libmygui.openglplatform0debian1v5
+Package: libmygui.openglplatform0debian1t64
+Provides: ${t64:Provides}
+X-Time64-Compat: libmygui.openglplatform0debian1v5
+Breaks: libmygui.openglplatform0debian1v5 (<< ${source:Version})
 Architecture: any
 Conflicts: libmygui.openglplatform0debian1
-Replaces: libmygui.openglplatform0debian1
+Replaces: libmygui.openglplatform0debian1v5, libmygui.openglplatform0debian1
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: Fast, simple and flexible GUI - OpenGL interface
  MyGUI is a GUI library which aims to be fast, flexible and simple GUIs in C++.
@@ -128,10 +137,13 @@
  .
  This package contains the MyGUI interface for OpenGL.
 
-Package: libmygui.opengl3platform0debian1v5
+Package: libmygui.opengl3platform0debian1t64
+Provides: ${t64:Provides}
+X-Time64-Compat: libmygui.opengl3platform0debian1v5
+Breaks: libmygui.opengl3platform0debian1v5 (<< ${source:Version})
 Architecture: any
 Conflicts: libmygui.opengl3platform0debian1
-Replaces: libmygui.opengl3platform0debian1
+Replaces: libmygui.opengl3platform0debian1v5, libmygui.opengl3platform0debian1
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: Fast, simple and flexible GUI - OpenGL3 interface
  MyGUI is a GUI library which aims to be fast, flexible and simple GUIs in C++.

=== debian/rules ===
#!/usr/bin/make -f

# resolves bug #984248: mygui: ftbfs with GCC-11
export DEB_CPPFLAGS_MAINT_APPEND = -DMYGUI_DONT_REPLACE_NULLPTR

DEB_UPSTREAM_VERSION=$(shell dpkg-parsechangelog | sed -rne 's,^Version: ([^+]+).*-.*,\1,p')
#export DH_VERBOSE=1
%:
	dh $@ --with pkgkde_symbolshelper

override_dh_auto_configure: debian/mygui-doc.docs
#	Don't autoconfigure, need to build for Ogre and OpenGL

override_dh_auto_install:
	mv $(CURDIR)/debian/tmp2 $(CURDIR)/debian/tmp

override_dh_auto_build:
#	build for OpenGL
	dh_auto_configure -- -DMYGUI_BUILD_DEMOS=FALSE -DMYGUI_RENDERSYSTEM=4 \
	 -DMYGUI_BUILD_DOCS=FALSE -DMYGUI_BUILD_PLUGINS=FALSE \
	 -DMYGUI_BUILD_TOOLS=FALSE -DMYGUI_USE_SYSTEM_GLEW=TRUE
	dh_auto_build
	${MAKE} install -C obj-$(DEB_BUILD_GNU_TYPE) DESTDIR=$(CURDIR)/debian/tmp2
#	build for OpenGL3
	dh_auto_configure -- -DMYGUI_BUILD_DEMOS=FALSE -DMYGUI_RENDERSYSTEM=7 \
	 -DMYGUI_BUILD_DOCS=FALSE -DMYGUI_BUILD_PLUGINS=FALSE \
	 -DMYGUI_BUILD_TOOLS=FALSE -DMYGUI_USE_SYSTEM_GLEW=TRUE
	dh_auto_build
	${MAKE} install -C obj-$(DEB_BUILD_GNU_TYPE) DESTDIR=$(CURDIR)/debian/tmp2
#	Build for Ogre platform, and tools
	dh_auto_configure -- -DMYGUI_BUILD_DEMOS=FALSE -DMYGUI_RENDERSYSTEM=3 \
	 -DMYGUI_BUILD_DOCS=TRUE -DMYGUI_BUILD_PLUGINS=FALSE \
	 -DMYGUI_BUILD_TOOLS=FALSE
	dh_auto_build
	${MAKE} install -C obj-$(DEB_BUILD_GNU_TYPE) DESTDIR=$(CURDIR)/debian/tmp2

override_dh_install:
	cd obj-$(DEB_BUILD_GNU_TYPE)/Docs && doxygen Doxyfile && cd $(CURDIR)
	find debian/ -type d -empty -delete
	mkdir -p $(CURDIR)/debian/tmp/usr/lib/${DEB_HOST_MULTIARCH}/pkgconfig
	mv $(CURDIR)/debian/tmp/usr/lib/pkgconfig/MYGUI.pc $(CURDIR)/debian/tmp/usr/lib/${DEB_HOST_MULTIARCH}/pkgconfig/MYGUI.pc
	dh_install -Xlicense.txt -Xttf

override_dh_installdocs:
	dh_installdocs -X.md5 -X.map -Xjquery.js

debian/%.docs: debian/%.docs.in
	sed 's/@BUILD_DIR@/obj-$(DEB_BUILD_GNU_TYPE)/g' $< > $@

override_dh_makeshlibs:
	dh_makeshlibs -- -c0 -v$(DEB_UPSTREAM_VERSION)

copyright_check:
	${MAKE} -f /usr/share/cdbs/1/rules/utils.mk debian/stamp-copyright-check
	rm debian/stamp-copyright-check
